// t2sDlg.cpp : implementation file
// Copyright(C) Sollae Systems Co.,Ltd.
// 06.Nov.2000 yyc  initial touch
//

#include "stdafx.h"
#include "ezsock.h"
#include "t2s.h"
#include "t2sDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CT2sDlg dialog

CT2sDlg::CT2sDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CT2sDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CT2sDlg)
	m_tcp_port = 0;
	m_send_txt = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CT2sDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CT2sDlg)
	DDX_Control(pDX, IDC_CHECK_LF, m_check_lf);
	DDX_Control(pDX, IDC_CHECK_CR, m_check_cr);
	DDX_Control(pDX, IDC_SEND, m_send);
	DDX_Control(pDX, IDC_EDIT_SEND, m_send_box);
	DDX_Control(pDX, IDC_CONSOLE, m_console);
	DDX_Control(pDX, IDC_REMOTE_IP, m_remote_ip);
	DDX_Control(pDX, IDC_DISCONNECT, m_disconnect);
	DDX_Control(pDX, IDC_CONNECT, m_connect);
	DDX_Text(pDX, IDC_TCP_PORT, m_tcp_port);
	DDV_MinMaxUInt(pDX, m_tcp_port, 0, 65535);
	DDX_Text(pDX, IDC_EDIT_SEND, m_send_txt);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CT2sDlg, CDialog)
	//{{AFX_MSG_MAP(CT2sDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_DISCONNECT, OnDisconnect)
	ON_BN_CLICKED(IDC_EXIT, OnExit)
	ON_BN_CLICKED(IDC_SEND, OnSend)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CT2sDlg message handlers

BOOL CT2sDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_disconnect.EnableWindow(FALSE);	
	m_send.EnableWindow(FALSE);
	m_socket.m_app = (void *)this;
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CT2sDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CT2sDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CT2sDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

CString CT2sDlg::addr2str(CIPAddressCtrl& ip_addr)
{
	BYTE a0, a1, a2, a3;
	CString addrstr;
	
	ip_addr.GetAddress(a0, a1, a2, a3);
	addrstr.Format("%u.%u.%u.%u", a0, a1, a2, a3);
	return addrstr;
}

void CT2sDlg::OnConnect() 
{
	SOCKADDR_IN saddr;
	CString msg;

	UpdateData(TRUE);
	m_socket.Create(0, SOCK_STREAM);
	saddr.sin_family = AF_INET;
	saddr.sin_addr.s_addr = inet_addr(addr2str(m_remote_ip));
	saddr.sin_port = htons(m_tcp_port);
	m_socket.Connect((SOCKADDR *)&saddr, sizeof(saddr));
	m_connect.EnableWindow(FALSE);
	m_disconnect.EnableWindow(TRUE);
	msg.Format("Connect to %s(%u)....", addr2str(m_remote_ip), m_tcp_port);
	m_console.ReplaceSel(msg);
}

void CT2sDlg::OnDisconnect() 
{
	m_socket.Close();
	m_console.ReplaceSel("Close connection.\r\n");
	m_connect.EnableWindow(TRUE);
	m_disconnect.EnableWindow(FALSE);
	m_send.EnableWindow(FALSE);
}

void CT2sDlg::OnExit() 
{
	PostQuitMessage(0);	
}

// Callback functions
void CT2sDlg::DlgOnConnect(int nErrorCode)
{
	if(nErrorCode)
	{
		m_socket.Close();
		m_console.ReplaceSel("Connect fail.\r\n");
		m_connect.EnableWindow(TRUE);
		m_disconnect.EnableWindow(FALSE);
	}
	else
	{
		m_console.ReplaceSel("Connected.\r\n");
		m_send.EnableWindow(TRUE);
	}
}

void CT2sDlg::DlgOnReceive(int nErrorCode)
{
	int len, count;
	CString msg;
	BYTE buf[1024];

	len = m_socket.Receive(buf, 1024, 0);
	for(count = 0; count < len; count++)
	{
		msg = buf[count];
		m_console.ReplaceSel(msg);
	}
}

void CT2sDlg::DlgOnClose(int nErrorCode)
{
	m_socket.Close();
	m_console.ReplaceSel("Connection closed.\r\n");
	m_connect.EnableWindow(TRUE);
	m_disconnect.EnableWindow(FALSE);
	m_send.EnableWindow(FALSE);
}

void CT2sDlg::OnSend() 
{
	char buf[128];

	UpdateData(TRUE);

	m_socket.Send(m_send_txt, m_send_txt.GetLength(), 0);

	if(m_check_cr.GetCheck())
	{
		buf[0] = 0x0d;
		m_socket.Send(buf, 1 ,0);
	}
	if(m_check_lf.GetCheck())
	{
		buf[0] = 0x0a;
		m_socket.Send(buf, 1 ,0);
	}

	UpdateData(FALSE);
}
